.386
.model flat,stdcall
option casemap:none

WinMain proto :DWORD,:DWORD,:DWORD,:DWORD

include \masm32\include\windows.inc
include \masm32\include\user32.inc
include \masm32\include\kernel32.inc
include \masm32\include\gdi32.inc 
includelib \masm32\lib\user32.lib
includelib \masm32\lib\kernel32.lib
includelib \masm32\lib\gdi32.lib 
; -------------------------------------------------------------------------
.data
ClassName db "Edit",0
;ClassName db "SimpleWinClass",0
EditClass db "EDIT",0 
; -------------------------------------------------------------------
;   From Iczilions Tutorial 4. Changed Sept 2008                    ;
; -------------------------------------------------------------------
AppName  db "Our First Window",0
OurText  db "Win32 assembly test string 1A!",0Ah,0Dh, "Next Line",0Ah,0Dh

TestString  db "Win32 assembly Test string 2 "

char WPARAM 20h                         ; the character the program receives from keyboard 
pointer DD    0                         ; pointer to move char about
.data?
hInstance HINSTANCE ?
hwndEdit dd ? 

CommandLine LPSTR ?
; -------------------------------------------------------------------------
.code
start:
	invoke GetModuleHandle, NULL
	mov    hInstance,eax
	invoke GetCommandLine
	invoke WinMain, hInstance,NULL,CommandLine, SW_SHOWDEFAULT

	invoke ExitProcess,eax
; -------------------------------------------------------------------------
WinMain proc hInst:HINSTANCE,hPrevInst:HINSTANCE,CmdLine:LPSTR,CmdShow:DWORD
	LOCAL wc:WNDCLASSEX
	LOCAL msg:MSG
	LOCAL hwnd:HWND
	mov   wc.cbSize,SIZEOF WNDCLASSEX
	mov   wc.style, CS_HREDRAW or CS_VREDRAW
	mov   wc.lpfnWndProc, OFFSET WndProc
	mov   wc.cbClsExtra,NULL
	mov   wc.cbWndExtra,NULL
	push  hInst
	pop   wc.hInstance
	mov   wc.hbrBackground,COLOR_WINDOW+1
	mov   wc.lpszMenuName,NULL
	mov   wc.lpszClassName,OFFSET ClassName
	invoke LoadIcon,NULL,IDI_APPLICATION
	mov   wc.hIcon,eax
	mov   wc.hIconSm,0
	invoke LoadCursor,NULL,IDC_ARROW
	mov   wc.hCursor,eax
	invoke RegisterClassEx, addr wc
	INVOKE CreateWindowEx,WS_EX_CLIENTEDGE,ADDR ClassName,ADDR AppName,\
           WS_OVERLAPPEDWINDOW+ ES_MULTILINE+ ES_AUTOHSCROLL+ ES_AUTOVSCROLL,CW_USEDEFAULT,\
           CW_USEDEFAULT,600,400,NULL,NULL,\
           hInst,NULL
	mov   hwnd,eax
	INVOKE ShowWindow, hwnd,SW_SHOWNORMAL
	INVOKE UpdateWindow, hwnd
	.WHILE TRUE
                INVOKE GetMessage, ADDR msg,NULL,0,0
                .BREAK .IF (!eax)
                INVOKE TranslateMessage, ADDR msg
                INVOKE DispatchMessage, ADDR msg
	.ENDW
	mov     eax,msg.wParam
	ret
WinMain endp
; -------------------------------------------------------------------------
WndProc proc hWnd:HWND, uMsg:UINT, wParam:WPARAM, lParam:LPARAM
	LOCAL hdc:HDC
	LOCAL ps:PAINTSTRUCT
	LOCAL rect:RECT
	.IF uMsg==WM_DESTROY
		invoke PostQuitMessage,NULL

 ;   .ELSEIF uMsg==WM_CREATE 
 ;       invoke CreateWindowEx,NULL,addr EditClass, NULL,/
 ;           WS_CHILD+ WS_VISIBLE+ ES_MULTILINE+ ES_AUTOHSCROLL+ ES_AUTOVSCROLL,/
 ;           0, 0, 0, 0, hWnd, NULL, hInstance, NULL 
 ;       mov hwndEdit,eax 
 ;       push eax
 ;       call SetFocus

      .ELSEIF uMsg==WM_CHAR 
            push wParam 
            pop  char 
            invoke InvalidateRect, hWnd,NULL,TRUE 

	.ELSEIF uMsg==WM_PAINT
		invoke BeginPaint,hWnd, ADDR ps
		mov    hdc,eax
		invoke GetClientRect,hWnd, ADDR rect
		invoke DrawText, hdc,ADDR OurText,-1, ADDR rect, DT_EDITCONTROL+DT_WORDBREAK
		invoke DrawText, hdc,ADDR OurText,-1, ADDR rect, DT_EDITCONTROL+DT_WORDBREAK

        mov eax,[pointer]           ; Move the position of the character
        inc eax
        mov [pointer],eax    
        imul eax,8 

        invoke TextOut,hdc,eax,48,ADDR char,1 

        invoke SetBkColor,hdc,0ffFFh 
        invoke TextOut,hdc,300,0,ADDR TestString,SIZEOF TestString 

        invoke TextOut,hdc,100,64,ADDR TestString,SIZEOF TestString 

		invoke EndPaint,hWnd, ADDR ps
	.ELSE
		invoke DefWindowProc,hWnd,uMsg,wParam,lParam
		ret
	.ENDIF
	xor    eax,eax
	ret
WndProc endp
; -------------------------------------------------------------------------
end start
