.386
.model flat,stdcall
option casemap:none
include \masm32\include\windows.inc
include \masm32\include\user32.inc
include \masm32\include\kernel32.inc
include \masm32\include\gdi32.inc
includelib \masm32\lib\gdi32.lib
includelib \masm32\lib\user32.lib
includelib \masm32\lib\kernel32.lib

WinMain PROTO :DWORD,:DWORD,:DWORD,:DWORD

.const
IDR_MAINMENU	equ 101
;IDM_ASSEMBLE	equ 40001


.data
ClassName 	db "PipeWinClass",0
AppName  	db "Text Window",0
EditClass	db "EDIT",0

.data?
hInstance	HINSTANCE ?
hwndEdit	dd ?
; -------------------------------------------------------------------------
.code
start:
	invoke GetModuleHandle, NULL
	mov    hInstance,eax
	invoke WinMain, hInstance,NULL,NULL, SW_SHOWDEFAULT
	invoke ExitProcess,eax
; -------------------------------------------------------------------------
WinMain proc hInst:DWORD,hPrevInst:DWORD,CmdLine:DWORD,CmdShow:DWORD
	LOCAL wc:WNDCLASSEX
	LOCAL msg:MSG
	LOCAL hwnd:HWND
	mov   wc.cbSize,SIZEOF WNDCLASSEX
	mov   wc.style, CS_HREDRAW or CS_VREDRAW
	mov   wc.lpfnWndProc, OFFSET WndProc
	mov   wc.cbClsExtra,NULL
	mov   wc.cbWndExtra,NULL
	push  hInst
	pop   wc.hInstance
	mov   wc.hbrBackground,COLOR_APPWORKSPACE
	mov   wc.lpszMenuName,IDR_MAINMENU
	mov   wc.lpszClassName,OFFSET ClassName
	invoke LoadIcon,NULL,IDI_APPLICATION
	mov   wc.hIcon,eax
	mov   wc.hIconSm,eax
	invoke LoadCursor,NULL,IDC_ARROW
	mov   wc.hCursor,eax
	invoke RegisterClassEx, addr wc
	invoke CreateWindowEx,WS_EX_CLIENTEDGE,ADDR ClassName,ADDR AppName,\
           WS_OVERLAPPEDWINDOW+WS_VISIBLE,\
	   300,300, 600,400,\  ;CW_USEDEFAULT,600,400,\
	   NULL,NULL,hInst,NULL
	mov hwnd,eax

x1:	invoke GetMessage, ADDR msg,NULL,0,0
	or eax,eax
	jz x2
	invoke TranslateMessage, ADDR msg
	invoke DispatchMessage, ADDR msg
	jmp x1

x2:	mov eax,msg.wParam
	ret
WinMain endp
; -------------------------------------------------------------------------
WndProc proc hWnd:HWND, uMsg:UINT, wParam:WPARAM, lParam:LPARAM
mov eax,uMsg
	.if uMsg==WM_CREATE
		invoke CreateWindowEx,NULL,addr EditClass,NULL,\
		   WS_CHILD+WS_VISIBLE+ES_MULTILINE+ES_AUTOHSCROLL+ES_AUTOVSCROLL,\
		   0,0,0,0,hWnd,NULL,hInstance,NULL
		mov hwndEdit,eax
		push eax
		call SetFocus
	.elseif uMsg==WM_CTLCOLOREDIT		; sets colours of window
		invoke SetTextColor,wParam,0FFh
		invoke SetBkColor,wParam,White
		invoke GetStockObject,WHITE_BRUSH
		ret		;needs return to work
	.elseif uMsg==WM_SIZE			; seems to paint window
		mov edx,lParam
		mov ecx,edx
		shr ecx,16
		and edx,0ffffh
		invoke MoveWindow,hwndEdit,0,0,edx,ecx,TRUE

	.elseif uMsg==WM_CHAR
			mov eax,wParam
h1:		jmp h1

	.elseif uMsg==WM_DESTROY
		invoke PostQuitMessage,NULL
	.else
		invoke DefWindowProc,hWnd,uMsg,wParam,lParam		
		ret
	.endif
	xor eax,eax
	ret
WndProc endp
; -------------------------------------------------------------------------
end start
